hdu 5898 odd-even number(数位dp)

Problem Description

For a number,if the length of continuous odd digits is even and the length of continuous even digits is odd,we call it odd-even number.Now we want to know the amount of odd-even number between L,R(1<=L<=R<= 9*10^18).

Input

First line a t,then t cases.every line contains two integers L and R.

Output

Print the output for each case on one line in the format as shown below.

题意:一个数中所有连续的奇数长度都为偶数,所有连续偶数的长度都为奇数。我们要找一个区间内一共有多少个这样的数。

区间范围(1~9*10^18)所以显然是数位dp搞。设dp[len][count][temp],temp=1表示偶数,temp=2表示奇数,temp=0表示取首位0时,

count表示到len位置有几个奇数或偶数个。显然简单的搜索,标准数位dp

#include <iostream>
#include <cstring>
using namespace std;
typedef long long ll;
ll dp[22][22][3];
int dig[20];
ll dfs(int len , int count , int temp , int flag , int first) {
    if(len == 0) {
        if(temp == 1) {
            if(count % 2 != 0) {
                return 1;
            }
            else {
                return 0;
            }
        }
        if(temp == 2) {
            if(count % 2 == 0) {
                return 1;
            }
            else {
                return 0;
            }
        }
        return 0;
    }
    if(!flag && !first && dp[len][count][temp] != -1) {
        return dp[len][count][temp];
    }
    int n = flag ? dig[len] : 9;
    ll sum = 0;
    for(int i = 0 ; i <= n ; i++) {
        if(first) {
            if(i == 0) {
                sum += dfs(len - 1 , 0 , 0 , flag && i == n , first && i == 0);
            }
            else {
                if(i % 2 == 0) {
                    sum += dfs(len - 1 , count + 1 , 1 , flag && i == n , first && i == 0);
                }
                else {
                    sum += dfs(len - 1 , count + 1 , 2 , flag && i == n , first && i == 0);
                }
            }
        }
        else {
            if(i % 2 == 0) {
                if(temp == 1) {
                    sum += dfs(len - 1 , count + 1 , 1 , flag && i == n , first && i == 0);
                }
                if(temp == 2) {
                    if(count % 2 == 0) {
                        sum += dfs(len - 1 , 1 , 1 , flag && i == n , first && i == 0);
                    }
                }
            }
            else {
                if(temp == 1) {
                    if(count % 2 != 0) {
                        sum += dfs(len - 1 , 1 , 2 , flag && i == n , first && i == 0);
                    }
                }
                if(temp == 2) {
                    sum += dfs(len - 1 , count + 1 , 2 , flag && i == n , first && i == 0);
                }
            }
        }
    }
    if(!flag && !first) {
        dp[len][count][temp] = sum;
    }
    return sum;
}
ll Get(ll x) {
    int len = 0;
    memset(dp , -1 , sizeof(dp));
    memset(dig , 0 , sizeof(dig));
    if(x == 0)
        len = 1;
    while(x) {
        dig[++len] = x % 10;
        x /= 10;
    }
    return dfs(len , 0 , 0 , 1 , 1);
}
int main()
{
    int t;
    cin >> t;
    int ans = 0;
    while(t--) {
        ans++;
        ll l , r , gg;
        cin >> l >> r;
        cout << "Case #" << ans << ": " << Get(r) - Get(l - 1) << endl;
    }
    return 0;
}
时间: 2024-12-27 00:14:04

hdu 5898 odd-even number(数位dp)的相关文章

[hdu 4933]Miaomiao&#39;s Function 数位DP+大数

Miaomiao's Function Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 79    Accepted Submission(s): 18 Problem Description Firstly , Miaomiao define two functions f(x) , g(x): (K is the smallest

hdu 5623 KK&#39;s Number(dp)

问题描述 我们可爱的KK有一个有趣的数学游戏:这个游戏需要两个人,有N\left(1\leq N\leq 5*{10}^{4} \right)N(1≤N≤5∗10?4??)个数,每次KK都会先拿数.每次可以拿任意多个数,直到NN个数被拿完.每次获得的得分为取的数中的最小值,KK和对手的策略都是尽可能使得自己的得分减去对手的得分更大.在这样的情况下,最终KK的得分减去对手的得分会是多少? 输入描述 第一行一个数T\left( 1\leq T\leq 10\right)T(1≤T≤10),表示数据组

hdu 2089 不要62 (数位dp)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2089 思路:用变量记录吉利数,和最高位为2的吉利数还有不是吉利数的个数... code: #include<cstdio> #include<cstring> #include<algorithm> using namespace std; int dp[10][3]; //dp[i][j] ,i表示位数,j表示状态<pre name="code"

Hdu3079Balanced Number数位dp

枚举支点,然后就搞,记录之前的点的力矩和. #include <cstdio> #include <cstring> #include <algorithm> #include <climits> #include <string> #include <iostream> #include <map> #include <cstdlib> #include <list> #include <s

HDU 4352 XHXJ&#39;s LIS 数位DP + 状压

由LIS的nlogn解法 可以得出最后统计数组中数的个数即为LIS的长度 这样就可以状压了 #include <cstdio> #include <cstring> #include <cmath> #include <algorithm> #include <climits> #include <string> #include <iostream> #include <map> #include <c

HDU 4352 XHXJ&#39;s LIS 数位dp

题目链接:点击打开链接 题意: 一个数自身的最长子序列=每一位都是一个数字然后求的LIS 问区间内有多少个数 自身的最长子序列==k 思路: 因为自身的最长子序列至多=10,且由0~9组成,所以状压10个二进制表示0~9中哪些数字已经用过 dp[i][j] 表示长度为i的数字,最长子序列中出现的数字状态j的方法数.由于询问数=K,也存下来避免重复计算. #include <cstdio> #include <algorithm> #include <cstring> #

SPOJ MYQ10 Mirror Number 数位dp&#39;

题目链接:点击打开链接 MYQ10 - Mirror Number A number is called a Mirror number if on lateral inversion, it gives the same number i.e it looks the same in a mirror. For example 101 is a mirror number while 100 is not. Given two numbers a and b, find the number

HDU 4588 Count The Carries 数位DP || 打表找规律

2013年南京邀请赛的铜牌题...做的很是伤心,另外有两个不太好想到的地方....a 可以等于零,另外a到b的累加和比较大,大约在2^70左右. 首先说一下解题思路. 首先统计出每一位的1的个数,然后统一进位. 设最低位为1,次低位为2,依次类推,ans[]表示这一位上有多少个1,那么有 sum += ans[i]/2,ans[i+1] += ans[i]/2; sum即为答案. 好了,现在问题转化成怎么求ans[]了. 打表查规律比较神奇,上图不说话. 打表的代码 #include <algo

多校5 HDU5787 K-wolf Number 数位DP

1 // 多校5 HDU5787 K-wolf Number 数位DP 2 // dp[pos][a][b][c][d][f] 当前在pos,前四个数分别是a b c d 3 // f 用作标记,当现在枚举的数小于之前的数时,就不用判断i与dig[pos]的大小 4 // 整体来说就,按位往后移动,每次添加后形成的数都小于之前的数,并且相邻k位不一样,一直深搜到cnt位 5 // http://blog.csdn.net/weizhuwyzc000/article/details/5209769

HDU 4933 Miaomiao&#39;s Function(数位DP + 高精度)

题目连接 : http://acm.hdu.edu.cn/showproblem.php?pid=4933 题意 : 自己看吧,还是很容易理解的,就一个公式而已. 方法 : 比赛的时候想到两次数位DP:先对所有的数进行一次mod9 的数位DP,再得出的答案x为新的mod,再进行一次mod,后来写着写着发现似乎有点问题,对于answer = 0要特判,然后没想到好的方法,比赛就结束了. 赛后用java写了一发大数过的,对于题解中用多个大质数去判这种神奇的作法只能意会下了 , 貌似rand() 也行